<?php
/** @noinspection PhpUnused */
/** @noinspection PhpMultipleClassDeclarationsInspection */
declare(strict_types=1);

namespace SpaethTech\Tests\ORM\Models;

use DateTime;
use SpaethTech\ORM\Attributes\Column;
use SpaethTech\ORM\Attributes\ExcludeIf;
use SpaethTech\ORM\Attributes\ID;
use SpaethTech\ORM\Attributes\Serializer;
use SpaethTech\ORM\Attributes\Table;
use SpaethTech\ORM\Methods\DatabaseMethod;
use SpaethTech\ORM\Model;
use SpaethTech\ORM\Serializers\DateTimeSerializer;
use SpaethTech\ORM\Serializers\EnumSerializer;
use SpaethTech\Tests\ORM\Enums\UserNotifications;
use SpaethTech\Tests\ORM\Enums\UserStatus;

/**
 * Class User
 *
 * @author Ryan Spaeth <rspaeth@spaethtech.com>
 * @copyright 2024 Spaeth Technologies Inc.
 *
 * @method string getSid()
 * @method string getWorkspaceSid()
 * @method string getGroupSid()
 * @method string getContactSid()
 * @method string getPassword()
 * @method UserStatus getStatus()
 * @method UserNotifications getNotifications()
 * @method int getSessionTimeout()
 * @method DateTime getCreated()
 * @method DateTime|null getUpdated()
 *
 * @method self setSid(string $Sid)
 * @method self setWorkspaceSid(string $WorkspaceSid)
 * @method self setGroupSid(string $GroupSid)
 * @method self setContactSid(string $ContactSid)
 * @method self setPassword(string $Password)
 * @method self setStatus(UserStatus $Status)
 * @method self setNotifications(UserNotifications $Notifications)
 * @method self setSessionTimeout(int $SessionTimeout)
 * @method self setCreated(DateTime $Created)
 * @method self setUpdated(DateTime|null $Updated)
 *
 * @generated by Robo 2024-04-17 15:19:34
 *
 * @template-extends Model<self>
 */
#[Table('users')]
class User extends Model
{
	#[ID]
	#[Column('sid')]
	protected string $Sid;

	#[Column('workspace_sid')]
	protected string $WorkspaceSid;

	#[Column('group_sid')]
	protected string $GroupSid;

	#[Column('contact_sid')]
	protected string $ContactSid;

	#[Column('password')]
	protected string $Password;

	#[Column('status')]
	#[Serializer(EnumSerializer::class)]
	protected UserStatus $Status;

	#[Column('notifications')]
	#[Serializer(EnumSerializer::class)]
	protected UserNotifications $Notifications;

	#[Column('session_timeout')]
	protected int $SessionTimeout = 60;

	#[Column('created')]
	#[ExcludeIf(DatabaseMethod::INSERT)]
	#[Serializer(DateTimeSerializer::class)]
	protected DateTime $Created;

	#[Column('updated')]
	#[ExcludeIf(DatabaseMethod::INSERT)]
	#[Serializer(DateTimeSerializer::class)]
	protected ?DateTime $Updated;
}

